/*************************************************************************
***	Authentication, authorization, accounting + firewalling package
***	(c) 1998-2002 Anton Vinokurov <anton@netams.com>
***	(c) 2002-2005 NeTAMS Development Team
***	All rights reserved. See 'Copying' file included in distribution
***	For latest version and more info, visit this project web page
***	located at http://www.netams.com
***
*************************************************************************/
/* $Id: config.h,v 1.15 2005/01/17 13:13:21 jura Exp $ */

// Global includes from standard libraries
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <time.h>
#include <math.h>
#include <sys/resource.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>

#include <net/if_arp.h>
#include <sys/ioctl.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <sched.h>
#include <stdarg.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <pthread.h>
#include <limits.h>
#include <poll.h>

#ifdef PVM
//#include <pvm3.h>
#endif

#define __FAVOR_BSD 	1	//this is dirty hack -D_BSD_SOURCE should work but do not

#include <netinet/tcp.h>
#include <netinet/udp.h>

#include <net/if.h>
#include <netinet/if_ether.h>

#ifdef LINUX
#include <netinet/ether.h>
#include <sys/statvfs.h>
#define statvfs_name_local statvfs

#ifndef IPTBL_NONE
#ifndef _LINUX_IF_H
#define _LINUX_IF_H
#endif
extern "C" {
	#include <linux/netfilter.h>
	#include <libipq.h>
}
#endif
#endif

#ifdef SOLARIS

#include <sys/loadavg.h>
#include <sys/statvfs.h>
#define statvfs_name_local statvfs

typedef void (*sig_t) (int);
typedef unsigned int     u_int32_t;
typedef unsigned short     u_int16_t;
typedef unsigned char     u_int8_t;

int daemon(int nochdir, int noclose);
int vasprintf(char **ret, const char *format, va_list ap);
struct ether_addr *ether_aton(const char *a);
char *ether_ntoa(const struct ether_addr *n);

#define TIMEVAL_TO_TIMESPEC(tv, ts)                                     \
        do {                                                            \
                (ts)->tv_sec = (tv)->tv_sec;                            \
                (ts)->tv_nsec = (tv)->tv_usec * 1000;                   \
        } while (0)
#define IP_OFFMASK      0x1fff
#define ETHER_ADDR_LEN          6
#define ETHER_TYPE_LEN          2
#define ETHER_HDR_LEN           (ETHER_ADDR_LEN*2+ETHER_TYPE_LEN)

#endif

#if defined(FREEBSD) || defined(OPENBSD) || defined(NETBSD)
	#include <sys/param.h>
	#include <sys/event.h>
	#include <sys/sysctl.h>
	#include <net/if_dl.h>
	#include <net/if_types.h>
	#include <net/route.h>
	#include <sys/mount.h>
#define statvfs_name_local statfs
#endif

//since OpenBSD have broken libpcap
#if defined(OPENBSD)
#define PCAP_NEED_POLL
#endif

#if __GNUC__ == 2
#define OLD_GCC
#endif

#ifdef DMALLOC
#include <dmalloc.h>
#endif
